#include "jewel.h"

void
Jewel::draw0()
	{
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, shininess);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, glfModelSpecular);
	glColor3f(r_diffuseColor, g_diffuseColor, b_diffuseColor);
	
	float drawx = pos[0] * GRIDSIZEX + GRIDORIGX;
	float drawy = pos[1] * GRIDSIZEY + GRIDORIGY;
	float drawz = pos[2] * GRIDSIZEZ + GRIDORIGZ;
	//printf( "pos xyz: %f %f %f\n", pos[0], pos[1], pos[2] );
	//printf( "dest xyz: %d %d %d\n", dest[0], dest[1], dest[2] );
	//printf( "draw xyz: %f %f %f\n", drawx, drawy, drawz );
	glTranslatef( drawx, drawy, drawz );
	glutSolidSphere( 1.0, 8, 8 );
	}
	
void
Jewel::draw1()
	{
	draw0();
	}
	
void
Jewel::draw2()
	{
	draw0();
	}
	
void
Jewel::draw3()
	{
	draw0();
	}
	
void
Jewel::draw4()
	{
	draw0();
	}

void 
Jewel::update()
	{
	for ( int i=0; i<3; i++ )
		{
		//printf( "[%d] posi: %f desti: %d\n", i, pos[i], dest[i] );
		if ( pos[i] > ((float) dest[i] + THRESH) )
			{
			pos[i] -= timePassed * rate[i];
			if ( pos[i] < (float) dest[i] )
				{
				pos[i] = (float) dest[i];
				}
			// printf( "[%d] Moving %f\n", i, timePassed*rate[i]*-1 );
			}
		else if ( pos[i] < ((float) dest[i] - THRESH) )
			{
			pos[i] += timePassed * rate[i];
			if ( pos[i] > (float) dest[i] )
				{
				pos[i] = (float) dest[i];
				}
			// printf( "[%d] Moving %f\n", i, timePassed*rate[i] );
			}
		else
			{
			pos[i] = (float) dest[i];
			// printf( "[%d] becoming %f\n", i, pos[i] );
			}
		}	
	}

void 
Jewel::updatePos( int modx, int mody, int modz )
	{
	pos[0] += modx;
	pos[1] += mody;
	pos[2] += modz;
	}
	
void
Jewel::downFast()
	{
	pos[1] -= timePassed * rate[1];
	}

void
Jewel::quantitizePos()
	{
	for( int i=0; i<3; i++ )
		{
		int trunc = (int) pos[i];
		if ( pos[i] - trunc > 0.5 )
			{
			pos[i] = trunc + 1;
			}
		else
			{
			pos[i] = trunc;
			}
		}
	}
