/*
 * OpenGL(R) is a registered trademark of Silicon Graphics, Inc.
 */

#include "main.h"

int frame;
Display *disp;
double lasttime;
float timePassed;
 
void init(void) 
	{
	//glPushMatrix();

   	GLfloat position0[] = {0, 0, 0, 1.0};
	//GLfloat position1[] = { 0, 1.0, -6, 1.0};
	//GLfloat position2[] = { 0, -0.5, 1, 1.0};

	GLfloat light0dif[] = { .8, .8, .8, 1.0 };
	//GLfloat light1dif[] = { .8, .8, .8, 1.0 };
	//GLfloat light2dif[] = { .5, .5, .5, 1.0 };

	GLfloat light0spec[] = { .3, .3, .3, 1.0 };
	//GLfloat light1spec[] = { .1, .1, .1, 1.0 };
	//GLfloat light2spec[] = { .1, .1, .1, 1.0 };
	

   	//GLfloat amb[] = {1, 1, 1, 1.0};
   	//GLfloat amb[] = {0.1, 0.1, 0.1, 1.0};
   	//GLfloat amb[] = {0.0, 0.0, 0.0, 1.0};
   	//GLfloat lmamb[] = {0.2,0.2,0.2, 1.0};
   	//GLfloat lmamb[] = {0.1,0.1,0.1, 1.0};
   	//GLfloat spec[] = {.01,.01,.01,1};
   	//GLfloat shin = {1.0};
   	glClearColor (0.0, 0.0, 0.0, 0.0);

   	//glMaterialfv(GL_FRONT, GL_AMBIENT, amb);
   	//glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
   	//glMaterialf (GL_FRONT,GL_SHININESS, shin);
	
   	glLightfv (GL_LIGHT0, GL_POSITION, position0);
	glLightfv (GL_LIGHT0, GL_DIFFUSE, light0dif);
	glLightfv (GL_LIGHT0, GL_SPECULAR, light0spec);
	/*
	glLightfv (GL_LIGHT1, GL_POSITION, position1);
	glLightfv (GL_LIGHT1, GL_DIFFUSE, light1dif);
	glLightfv (GL_LIGHT1, GL_SPECULAR, light1spec);
	
	glLightfv (GL_LIGHT2, GL_POSITION, position2);
	glLightfv (GL_LIGHT2, GL_DIFFUSE, light2dif);
	glLightfv (GL_LIGHT2, GL_SPECULAR, light2spec);
   	*/

	//glLightModelfv (GL_LIGHT_MODEL_AMBIENT, lmamb);
   	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	
	//glEnable( GL_CULL_FACE );
   	glEnable( GL_LIGHTING );
   	glEnable( GL_LIGHT0 );
	//glEnable( GL_LIGHT1 );
	//glEnable( GL_LIGHT2 );
   	glEnable( GL_DEPTH_TEST );
   	glShadeModel ( SHADE_MODE );

   	glEnable( GL_COLOR_MATERIAL );
   	glColorMaterial(GL_FRONT, GL_DIFFUSE );
	glEnable( GL_AUTO_NORMAL );

	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	

	//glPopMatrix();
	}

void display(void)
	{
	frame++;
	setTimePassed();

	//GLfloat diff[] = {.7,.7,.7, 1.0};

   	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	disp->update();
	glPushMatrix();
	disp->draw();
	glPopMatrix();

   	//getchar();
   	//printf("swap buffers\n");
	glutSwapBuffers();
	}

void reshape (int w, int h)
	{
   	glViewport (0, 0, (GLsizei) w, (GLsizei) h); 
   	glMatrixMode (GL_PROJECTION);
   	glLoadIdentity ();
   	//gluPerspective(65.0, (GLfloat) w/(GLfloat) h, 1.0, 20.0);
   	gluPerspective(100.0, (GLfloat) w/(GLfloat) h, 1.0, 20.0);
   	glMatrixMode(GL_MODELVIEW);
   	glLoadIdentity();
   	//glTranslatef (0.0, 0.0, -5.0);
	}

void keyboard (unsigned char key, int x, int y)
	{
	switch(key)
		{
		case QUIT: 
			exit(42);
			break;
		case GOLEFT:
			disp->left();
			break;
		case GORIGHT:
			disp->right();
			break;
		case GODOWN:
			disp->down();
			break;
		case FASTDOWN:
			disp->fastDown();
			break;
		case FLIP:
			disp->flip();
			break;
		default:
			break;
		}	
	}

void keyboardSpecial (int key, int x, int y)
	{
	switch(key)
		{
		case GOLEFT_SPECIAL:
			disp->left();
			break;
		case GORIGHT_SPECIAL:
			disp->right();
			break;
		case FLIP_SPECIAL:
			disp->flip();
			break;
		case GODOWN_SPECIAL:
			disp->down();
			break;
		default:
			break;
		}
	}	

void motion( int x, int y )
	{
	//rotz -= x - mouseLastx;
	//mouseLastx = x;
	}

void mouse( int button, int state, int x, int y)
	{
	//mouseLastx = x;
	if (button == GLUT_LEFT_BUTTON) 
		{
		if (state == GLUT_DOWN) 
			{
			//shotcontrol->fire();
			//mouseDown = 1;
			} 
		else 
			{
			//mouseDown = 0;
			}
		}	
	}

void idle()
	{
	// UNDONE: should only call this if enough time has passed
	display();
	}

void
setTimePassed()
	{
	/*
	This stuff in unix specific (sys/time.h)
	timeval time;
	struct timezone tzone;
	tzone.tz_minuteswest = 0;
	if ( lasttime == 0 )
		{
		gettimeofday(&time, &tzone);
		lasttime = (double) time.tv_sec + (double) time.tv_usec * 1E-6;
		}
	gettimeofday(&time, &tzone);
	double currenttime = (double) time.tv_sec + (double) time.tv_usec * 1E-6;
	timePassed = currenttime - lasttime;
	//printf( "timepassed: %f\n", timePassed );
	lasttime = currenttime;
	*/

	static clock_t told=0;
	clock_t tnew,ris;
	tnew=clock();
	ris=tnew-told;
	told=tnew;
	timePassed = ( (double)(ris/(float)CLOCKS_PER_SEC) );
	//printf( "timepassed: %f\n", timePassed );
	}

int main(int argc, char** argv)
	{
	frame = 0;
	lasttime = 0;
	disp = new Display();	
   	glutInit(&argc, argv);
	
   	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
 
	glutInitWindowSize (WINDOW_X, WINDOW_Y); 
   
	glutInitWindowPosition (0, 0);
   
	glutCreateWindow (argv[0]);	
	init();
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutIdleFunc(idle);	
	
	// do keyboard	
	glutKeyboardFunc(keyboard);	
	glutSpecialFunc(keyboardSpecial);	
	// do mouse	
	glutMouseFunc(mouse);	
	glutMotionFunc(motion);	
	glutPassiveMotionFunc(motion);	
	// go to town

   	glutMainLoop();
   	return 0;
	}
