#ifndef PIECE_H
#define PIECE_H

#include "base.h"
#include "jewel.h"

class Piece;

class Piece
	{
	public:
	Piece( float origx, float origy, float origz, float fallRate )
		{
		doDraw = 1;
		for( int i=0; i<3; i++ )
			{
			float jewelPos[3];
			jewelPos[0] = origx;
			jewelPos[1] = origy + i;
			jewelPos[2] = origz;
			jewels[i] = new Jewel( pickJewel(), jewelPos, fallRate );
			}
		}

	void draw();
	void update();
	void updateXDest( int modxdest );
	void downFast();
	void setYPos( int newypos );
	void flip();
	Jewel * getJewel( int jewelNum )
		{
		return jewels[ jewelNum ];
		}

	int getXDest()
		{
		return jewels[0]->getXDest();
		}

	int getYDest()
		{
		return jewels[0]->getYDest();
		}

	float getXPos()
		{
		return jewels[0]->getXPos();
		}

	float getYPos()
		{
		return jewels[0]->getYPos();
		}

	void stopDrawingJewels()
		{
		doDraw = 0;
		}

	int getDoDraw()
		{
		return doDraw;
		}

	int
	pickJewel()
		{
		return (int)(( (rand()/(RAND_MAX+1.0)) * 4) + 0.5);
		}

	private:
	Jewel *jewels[3];
	int doDraw;
	};

#endif	

