#ifndef SCOREBOARD_H
#define SCOREBOARD_H

#include "base.h"
#include "textchar.h"

#define CURR_SCORE_LENGTH 7
#define SCOREBOARDSTARTX 7
#define SCOREBOARDSTARTY 10
#define SCOREBOARDSTARTZ -15
#define SCOREBOARDCHARWIDTH 2
#define SCOREBOARDCHARHEIGHT 2

#define BASESCOREPERPIECE 100
#define SCOREPERPIECEMULT 1000
#define PLACEPIECESCORE 50

class ScoreBoard;

class ScoreBoard
	{
	public:
	ScoreBoard( GLubyte newtexture )
		{
		texture = newtexture;
		for ( int i=0; i < CURR_SCORE_LENGTH; i++ )
			{
			currScore[i] = new TextChar( texture, '0', 
				SCOREBOARDSTARTX + (i*SCOREBOARDCHARWIDTH), 
				SCOREBOARDSTARTY, SCOREBOARDSTARTZ, 
				SCOREBOARDCHARWIDTH, SCOREBOARDCHARHEIGHT );
			}
		score = 0;
		setScore( 0 );
		}

	void draw();
	
	void addScore( int addScore )
		{
		score += addScore;
		setScore( score );
		}

	void setScore( int newScore )
		{
		score = newScore;
		int temp;
		for ( int i=0; i < CURR_SCORE_LENGTH; i++ )
			{
			temp = score / ( powf(10, i) );
			temp %= 10;
			char newChar;
			// ugly, but works, have to find a better way later
			switch ( temp )
				{
				case 0:
					newChar = '0';
					break;
				case 1:
					newChar = '1';
					break;
				case 2:
					newChar = '2';
					break;
				case 3:
					newChar = '3';
					break;
				case 4:
					newChar = '4';
					break;
				case 5:
					newChar = '5';
					break;
				case 6:
					newChar = '6';
					break;
				case 7:
					newChar = '7';
					break;
				case 8:
					newChar = '8';
					break;
				case 9:
					newChar = '9';
					break;
				default:
					newChar = '5';
					printf( "newChar is broken\n" );
					break;
				}

			currScore[CURR_SCORE_LENGTH - i - 1]->setChar( newChar );
			}
		}
	
	private:
	TextChar * currScore[CURR_SCORE_LENGTH];
	int score;
	GLubyte texture;
	};

#endif	
